function [inputv,outputv]=drawspec(sig,loc,winlength,wintype,ndft,db)
%read userdata from figure, 
% the userdata are: mtype, lpcorder, ceptap, filternumber, lifter
%which are from the left side of the figer
%---------------------stupid, I have to read ndft for it maybe changed by psd or spectrgram.
ht=findobj(gcbf,'Tag','ndftmenu');
ndft=get(ht,'Value');
%------------------------------------------
global fs;
%fs=fs;
para=get(gcbf,'UserData');
mtype=para(1);
%----------------------------------------
hup=findobj(gcbf,'Tag','Axes2');
subplot(hup);
ax=axis;
   %-------------------------------
   hand1=findobj(gcbf,'Tag','Axes1');
if gca~=hand1
   subplot(hand1);
end
hold on;
zlabel('non','UserData',[]);
if para(7)==0,cla;
else
   ht=findobj(gcbf,'Color',[0 0 .9]);
   set(ht,'Color',[0 .7 .9]);
end
%------------------------------------
%==========================================

switch mtype
   case 1,

if loc==[0 0 0 0] ,warn1(1);return,elseif loc(3)<0,return,end
sig=sig(:);
if db==1 ,ylabel('db'),else ylabel('linear'),end
%loc,winlength,wintype,ndft,db,
ndftn=32*(2^(ndft-1));
s=max(floor(loc(1)),1);
e=s+floor(loc(3));
mid=round((s+e)/2);
s=max(1,round(mid-winlength/2));
e=min(round(mid+winlength/2),length(sig));
sig=sig(s:e);
if s==1, sig=[zeros(winlength-length(sig),1);sig];  end
if e==length(sig);
   sig=[sig;zeros(winlength-length(sig),1) ]; 
end

if wintype==2
sig=sig.*hamming(length(sig));   
elseif wintype==3
sig=sig.*hanning(length(sig));   
end

f=abs(fft(sig,ndftn));
if db==1, f=20*log10(f);end

axis auto
hl=plot((1:ndftn/2)/ndftn*fs,f(1:ndftn/2));
outputv=f(1:ndftn/2);
set(hl,'Color',[0 0 .9]);
xlabel('Frequency in Hz');
%if db==1 , set(hand1,'YScale','log
title(['spectrum of the selected part, duration is ',num2str(winlength/fs*1000,4),'ms']);
%==================================================
case 2
   winovl=para(6);
   ndftn=32*(2^(ndft-1));
   if winovl>=winlength,
      winovl=floor(winlength/3);
      ht=findobj(gcbf,'Tag','EditText3');
      set(ht,'String',num2str(winovl));
      warn1(3);
   end

 
   if ndftn<winlength
      ndft=ceil(log2(winlength/32)+1);
      hh=findobj(gcbf,'Tag','ndftmenu');
      set(hh,'Value',ndft);
      ndftn=32*(2^(ndft-1));

   end
   switch wintype
   case 1 
      wind=ones(winlength,1);
   case 2
      wind=hamming(winlength);   
   case 3
         wind=hanning(winlength);
   end
%   winlength,winovl,
%    ndftn, winlength,winovl,
    t=gcbf;
    ax(3:4)=[0 fs/2];

    specgram(sig,ndftn,fs,wind,winovl);
        axis(ax);
    xlabel('Time in second');
    ylabel('Frequency in Hz');
    title('spectrogram of the entire speech');
 %===========================================   
 case 3

if loc==[0 0 0 0] ,warn1(1);return,elseif loc(3)<0,return,end
sig=sig(:);
if db==1 ,ylabel('db'),else ylabel('linear'),end
%loc,winlength,wintype,ndft,db,
ndftn=32*(2^(ndft-1));
s=max(floor(loc(1)),1);
e=s+floor(loc(3));
mid=round((s+e)/2);
s=max(1,round(mid-winlength/2));
e=min(round(mid+winlength/2),length(sig));
sig=sig(s:e);
if s==1, sig=[zeros(winlength-length(sig),1);sig];  end
if e==length(sig);
   sig=[sig;zeros(winlength-length(sig),1) ]; 
end

if wintype==2
sig=sig.*hamming(length(sig));   
elseif wintype==3
sig=sig.*hanning(length(sig));   
end

[A,G]=lpc(sig,para(2));
[h,w]=freqz(G,A,512);
h=abs(h);
if db==1, h=20*log10(h);end

axis auto 
hl=plot(w/pi*fs/2,h);
outputv=h;
set(hl,'Color',[0 0 .9]);
xlabel('Frequency in Hz');
title(['LPC spectrum of the selected part, duration is ',num2str(winlength/fs*1000,4),'ms']);

%=================================================
case 4
  
if loc==[0 0 0 0] ,warn1(1);return,elseif loc(3)<0,return,end
sig=sig(:);
if db==1 ,ylabel('db'),else ylabel('linear'),end
%loc,winlength,wintype,ndft,db,
ndftn=32*(2^(ndft-1));
s=max(floor(loc(1)),1);
e=s+floor(loc(3));
mid=round((s+e)/2);
s=max(1,round(mid-winlength/2));
e=min(round(mid+winlength/2),length(sig));
sig=sig(s:e);
if s==1, sig=[zeros(winlength-length(sig),1);sig];  end
if e==length(sig);
   sig=[sig;zeros(winlength-length(sig),1) ]; 
end

if wintype==2
sig=sig.*hamming(length(sig));   
elseif wintype==3
sig=sig.*hanning(length(sig));   
end

[A,G]=lpc(sig,para(2));
cep=lpctocep(A(2:end),G);
cep=liftercc(cep,para(5));
hl=plot(cep);
outputv=cep;

set(hl,'Color',[0 0 .9]);
t=axis;
axis([0,para(3),t(3),t(4)]);
xlabel('Index of LPC-CEP ');   
ylabel('LPC-CEP value');   
title(['LPC cepstrum of the selected part, duration is ',num2str(winlength/fs*1000,4),'ms']);
axis tight

%===================================================   
case 5

   if loc==[0 0 0 0] ,warn1(1);return,elseif loc(3)<0,return,end
sig=sig(:);
if db==1 ,ylabel('db'),else ylabel('linear'),end
%loc,winlength,wintype,ndft,db,
ndftn=32*(2^(ndft-1));
s=max(floor(loc(1)),1);
e=s+floor(loc(3));
mid=round((s+e)/2);
s=max(1,round(mid-winlength/2));
e=min(round(mid+winlength/2),length(sig));
sig=sig(s:e);
if s==1, sig=[zeros(winlength-length(sig),1);sig];  end
if e==length(sig);
   sig=[sig;zeros(winlength-length(sig),1) ]; 
end

if wintype==2
sig=sig.*hamming(length(sig));   
elseif wintype==3
sig=sig.*hanning(length(sig));   
end
fs,winlength,winlength,para(3),para(5),para(4),
[mfc,logfb,fb]=mfcc(sig,fs,winlength,winlength,para(3),para(5),para(4),0,0);
if db==1, fb=logfb;end


hl=plot(fb);
outputv=fb;
set(hl,'Color',[0 0 .9]);
xlabel('Index of Mel Filter');
title(['Mel filter output of the selected part, duration is ',num2str(winlength/fs*1000,4),'ms']);
axis tight

%======================================================
case 6

if loc==[0 0 0 0] ,warn1(1);return,elseif loc(3)<0,return,end
sig=sig(:);
if db==1 ,ylabel('db'),else ylabel('linear'),end
%loc,winlength,wintype,ndft,db,
ndftn=32*(2^(ndft-1));
s=max(floor(loc(1)),1);
e=s+floor(loc(3));
mid=round((s+e)/2);
s=max(1,round(mid-winlength/2));
e=min(round(mid+winlength/2),length(sig));
sig=sig(s:e);
if s==1, sig=[zeros(winlength-length(sig),1);sig];  end
if e==length(sig);
   sig=[sig;zeros(winlength-length(sig),1) ]; 
end

if wintype==2
sig=sig.*hamming(length(sig));   
elseif wintype==3
sig=sig.*hanning(length(sig));   
end
fs,winlength,winlength,para(3),para(5),para(4),
[mfc,logfb,fb]=mfcc(sig,fs,winlength,winlength,para(3),para(5),para(4),0,0);


hl=plot(mfc);
outputv=mfc;
%axis tight
set(hl,'Color',[0 0 .9]);
t=axis;
axis([0,para(3),t(3),t(4)]);
xlabel('Index of MFCC ');   
ylabel('MFCC value');
title(['MFCC of the selected part, duration is ',num2str(winlength/fs*1000,4),'ms']);
axis tight

%==============================
case 7
if loc==[0 0 0 0] ,warn1(1);return,elseif loc(3)<0,return,end
sig=sig(:);
if db==1 ,ylabel('db'),else ylabel('linear'),end
%loc,winlength,wintype,ndft,db,
ndftn=32*(2^(ndft-1));
s=max(floor(loc(1)),1);
e=s+floor(loc(3));
mid=round((s+e)/2);
s=max(1,round(mid-winlength/2));
e=min(round(mid+winlength/2),length(sig));
sig=sig(s:e);
if s==1, sig=[zeros(winlength-length(sig),1);sig];  end
if e==length(sig);
   sig=[sig;zeros(winlength-length(sig),1) ]; 
end

if wintype==2
sig=sig.*hamming(length(sig));   
elseif wintype==3
sig=sig.*hanning(length(sig));   
end
fs,winlength,winlength,para(3),para(5),para(4),
[mfc,logfb,fb]=mfcc(sig,fs,winlength,winlength,para(3),para(5),para(4),0,0);

spec=idct([0;mfc(:);zeros(para(4)-para(3)-1,1)]);

hl=plot(spec);
outputv=spec;
%axis tight
set(hl,'Color',[0 0 .9]);
t=axis;
axis([0,para(5),t(3),t(4)]);
xlabel('filter index ');   
ylabel('Mel filter output in DB');
title(['Mel filter output recovered from MFCC of the selected part, duration is ',num2str(winlength/fs*1000,4),'ms']);
axis tight
 %==================================  
case 8

if loc==[0 0 0 0] ,warn1(1);return,elseif loc(3)<0,return,end
sig=sig(:);
if db==1 ,ylabel('db'),else ylabel('linear'),end
%loc,winlength,wintype,ndft,db,
ndftn=32*(2^(ndft-1));
s=max(floor(loc(1)),1);
e=s+floor(loc(3));
mid=round((s+e)/2);
s=max(1,round(mid-winlength/2));
e=min(round(mid+winlength/2),length(sig));
sig=sig(s:e);
if s==1, sig=[zeros(winlength-length(sig),1);sig];  end
if e==length(sig);
  sig= [sig;zeros(winlength-length(sig),1) ];     
end

 
   if ndftn<winlength
      ndft=ceil(log2(winlength/32)+1);
      hh=findobj(gcbf,'Tag','ndftmenu');
      set(hh,'Value',ndft);
      ndftn=32*(2^(ndft-1));
      warn1(2);
   end
   
if wintype==2
mywin=hamming(length(sig));   
elseif wintype==3
mywin=hanning(length(sig));   
end

f=psd(sig,ndftn,fs,mywin);
if db==1, f=20*log10(f);end

axis auto
hl=plot((1:ndftn/2)/ndftn*fs,f(1:ndftn/2));
outputv=f(1:ndftn/2);

set(hl,'Color',[0 0 .9]);
xlabel('Frequency in Hz');

title(['Power spectrum density of the selected part, duration is ',num2str(winlength/fs*1000,4),'ms']);
   
   
end
%-------------------------------------------
%axis tight;
hm=findobj(gcbf,'Tag','soundbutton');
soundon=get(hm,'Value');
if soundon==1
   st=get(hm,'UserData')/3;
   t=floor(rand*2)+1;
   sound(st(:,t),fs);
end
drawstyle=0;
if drawstyle==1;
color=[0 1 0 
   0 0 1
   1 0 0
   .5 .5 0
   0 .5 .5
   .5 0 .5];
   
set(hl,'MarkerSize',3);
ln=length(findobj(gcbf,'MarkerSize',3));
set(hl,'Color',color(mod(ln,length(color))+1,:)  );
end
inputv=sig;